<%@ LANGUAGE = VBScript %>

<%
' ---------------------------------------------------------------
'
' -----------------------------------------------------
' copyright 2000 by voxeo corporation. (see LGPL.txt)
' -----------------------------------------------------
'
' v1.0 Coded in ASP
' v1.0 Coded by Stephen J. Lewis
'
' This application is a simple "Telephone Directory" or contact list
' that uses a comma delimited file for contact information.  It allows
' the caller to dial into a number, and then place an outbound call
' to a phone number in the list or send a voice message as an email
' attachment to an email address in the list.  If either of those are
' missing, the caller can still use the other sub.  This application
' was also coded in PHP and Perl.
'
' This zip file for this application contains the following files:				 
'     contactlist.asp       <---- This file
'     contactlist.php       <---- PHP version
'     contactlist.pl        <---- Perl version
'     contactlist.ini       <---- Comma delimited configuration file.  See the
'                                 header in that file for more details.
'     LGPL.txt              <---- opensource license agreement
'     readme.txt            <---- Introductory text file
'
' Several audio files are associated with this application:
'           greeting.wav
'           nocontactinfo.wav
'           onlyphone.wav
'           onlyemail.wav
'           bothphoneemail.wav
'           starkey.wav
'           returningtomainmenu.wav
'           emailmessage.wav
'           errormessage.wav
'           messagesent.wav
'           holdmusic.wav
'           callfailure.wav
'
' All audio files are PCM format, 8-bit, mono, unsigned.
'
'----------------------------------------------------------------

'------------------------------------------
' Change this variable to reflect your path
'------------------------------------------

Filename = "c:\inetpub\wwwroot\jumpstart\contactlist\contactlist.ini"

'-------------------------------------------------------------------------------------------

sub Initialize 
  response.write "<?xml version=""1.0"" encoding=""UTF-8""?>" 
  response.write "<callxml>"
  
  '------------------------------------------------------------------------
  ' This annoying little variable is simply incremented and passed along to
  ' avoid the AGS's caching.  This helps to ensure that a different URL
  ' query string will be passed.
  '------------------------------------------------------------------------  

  if (request("cachekiller") = "") then
    response.write "<assign var=""cachekiller"" value=""1""/>"
  else
	response.write "<assign var=""cachekiller"" value=""" & (request("cachekiller") + 1) & """/>"
  end if
end sub  ' Initialize sub

'-------------------------------------------------------------------------------------------

sub Closure
  response.write "</callxml>"
end sub  ' Closure sub

'-------------------------------------------------------------------------------------------

function GetContactList 
  Loopy1   = 0

  Dim TempFileHandle, GetFileHandle, TextStreamHandle, ContactList(), FileArray()
  
  Set TempFileHandle = Server.CreateObject("Scripting.FileSystemObject")
  
  '-------------------------------------------------------------------------
  ' Open file for reading (the 1) and use the default file format (the -2)
  '-------------------------------------------------------------------------
  
  set GetFileHandle = TempFileHandle.GetFile(Filename)
  set TextStreamHandle = GetFileHandle.OpenAsTextStream(1, -2)
  
  '----------------------------
  ' Read the file into an array
  '----------------------------
  
  do while not TextStreamHandle.AtEndOfStream
    Loopy = Loopy + 1
	
	'-------------------------------------------
	' Syntactically, this is not elegant, but we 
	' need to keep an "open-ended" array.
	'-------------------------------------------
	
	Redim Preserve FileArray(Loopy)
	FileArray(Loopy) = TextStreamHandle.ReadLine
  Loop
    
  '---------------
  ' Close the file
  '---------------

  TextStreamHandle.Close
  
  TotalLines = Loopy

  for Loopy = 1 to TotalLines
	 '---------------------------------------------------
	 ' We only want lines that do not start with a # sign
	 ' (which is a commented line), and lines that have
	 ' commas in them.
	 '---------------------------------------------------
	 
	 IsThereAComma = instr(FileArray(Loopy), ",")
	 PoundSign     = instr(FileArray(Loopy), "#")
	 
	 if ((PoundSign = 0) and ( IsThereAComma > 0 )) then
	   Loopy1 = Loopy1 + 1		 
	   Redim Preserve ContactList(Loopy1)	 	 
       ContactList(Loopy1) = FileArray(Loopy)	   
     end if
  next
  
  if (TotalLines = "0") then 
    ContactList(1) = "FILE NOT FOUND"
  end if
  
  '-----------------
  ' Return our array
  '-----------------
  
  GetContactList = ContactList
end function  ' GetContactList function
'-------------------------------------------------------------------------------------------

function GetTextMessage(ContactList) 
  Dim Text(5)

  Loopy = 1
  
  '---------------------------------------------------
  ' We want to use the offset variable because we only
  ' read 10 contacts at a time.  We obviously loop no
  ' more than 10 times as a result of that fact.
  '--------------------------------------------------- 
  
  TotalItems  = Ubound(ContactList)
  ArrayLength = TotalItems
  if TotalItems > 10 then
    TotalItems = 10
  end if
  
  for Loopy = 1 to TotalItems
    '-----------------------------------------------------------------------------
    ' Here we are simply splitting the line into its component parts via the comma
	'-----------------------------------------------------------------------------

	if (Loopy + Offset) <= ArrayLength then
      if ContactList(Loopy + Offset) <> "" then
        TempArray = Split(ContactList(Loopy + Offset), ",")			
						
	    '---------------------------------------------------------------------
	    ' If there is no name, then simply use "Unnamed Contact" when reading
	    '---------------------------------------------------------------------	
	
        if (TempArray(0) = "") then 
	      TempArray(0) = "Unnamed Contact"
	    end if
	
	    '----------------------------------------------
	    ' The text array stores five important strings:
	    '   text[1] is the message string
	    '   text[2] is the name string
	    '   text[3] is the phone string
	    '   text[4] is the email string
	    '   text[5] is the termdigit string
	    '----------------------------------------------
	
	    Text(1) = Text(1) & "For " & TempArray(0) & " press " & Loopy - 1 & ","
	    Text(2) = Text(2) & TempArray(0) & ","
	    Text(3) = Text(3) & TempArray(1) & ","
	    Text(4) = Text(4) & TempArray(2) & ","
	    Text(5) = Text(5) & Loopy - 1
	  end if
	end if
  next  ' while statement
  
  '-----------------------------------------------------------
  ' If we are in the middle of the contact list, then tack
  ' on a * as termdigit as the "move to the previous page" key.
  '------------------------------------------------------------
  
  if (Offset <> "0") then 
    Text(5) = Text(5) & "*"
	Text(1) = Text(1) & "To move back in your list, press the star key,"
  end if
  
  '----------------------------------------------------------
  ' If next item in the contact list is NOT empty, then tack
  ' on a # as termdigit as the "move to the next page" key.
  '----------------------------------------------------------  
  
  if (Ubound(ContactList) > (Loopy + Offset - 1)) then
    Text(5) = Text(5) & "#"
	Text(1) = Text(1) & "To move forward in your list, press the pound key,"	
  end if  ' if statement
  
  GetTextMessage = Text
end function  ' GetTextMessage sub

'-------------------------------------------------------------------------------------------

sub MainMenu 
  ContactList = GetContactList
  
  if (ContactList(1) = "FILE NOT FOUND") then
    response.write "<playaudio value=""inifileerror.wav""/>"
  else 
    response.write "<block label=""MainMenu"" " &_
                          "repeat=""3"">"   
						  
    '------------------------------------------------------------
    ' Because we only play 10 contacts at a time, we only want to
    ' play the initial greeting file if we are calling into the
    ' list for the first time.
    '------------------------------------------------------------
  
    if (FirstPass = "YES") then
      response.write "<playaudio value=""greeting.wav""/>"
    end if  ' if statement
  
    '---------------------------------------------------------------------------
    ' Get the text message from the array of contacts (uses the offset variable)
    '---------------------------------------------------------------------------
  
    Text = GetTextMessage(ContactList)
			   
    response.write "<text termdigits=""" & Text(5) & """>"
    response.write Text(1)
    response.write "</text>"
  
    '-------------------------------------------------------
    ' Now we want to loop through and add our event handlers
    '-------------------------------------------------------

    for Loopy = 1 to len(Text(5))
	  TempString = Mid(Text(5), Loopy, 1)
      response.write "<ontermdigit value=""" & TempString & """>"
	
	  '---------------------------
	  ' Move to previous set of 10
	  '---------------------------

	  if (TempString = "*") then
	    TempOffset = Offset - 10
	  
	    if (TempOffset < 0) then
		  TempOffset = 0
		end if
	  
	    response.write "<goto value=""contactlist.asp?menu=mainmenu&amp;offset=" & TempOffset & """/>"	  
	
	  '-----------------------
	  ' Move to next set of 10
	  '-----------------------
	
	  elseif (TempString = "#") then
	    TempOffset = Offset + 10
	  
	    response.write "<goto value=""contactlist.asp?menu=mainmenu&amp;offset=" & TempOffset & """/>"		
	
	  '--------------------
	  ' Actual contact name
	  '--------------------
	
	  else 
	    '-----------------------------------------------
		' We want to extract from our individual strings
		' the email, telephone number, and name of the
		' contact according to our loop variable.
		'-----------------------------------------------
		
	    TempArray = Split(Text(4), ",")
	    Email     = TempArray(Loopy - 1)
	  
	    TempArray = Split(Text(3), ",")
	    Phone     = TempArray(Loopy - 1)
	  
	    TempArray = Split(Text(2), ",")
	    Name      = TempArray(Loopy - 1)
	  
	    response.write "<goto value=""contactlist.asp?menu=submenu&amp;email=" & Email &_
	              "&amp;phone="  & Phone &_
				  "&amp;name="   & Name  &_
	  			  "&amp;offset=" & Offset & """ " &_
				  "submit=""*"" method=""get""/>"
	  end if  ' else statement
	
	  response.write "</ontermdigit>"
    next  ' for loop  
  
    response.write "<wait value=""3s"" termdigits=""" & Text(5) & """/>"
  
    response.write "</block>"	
  end if  ' else statement (ini file was found)
end sub  ' MainMenu sub

'-------------------------------------------------------------------------------------------

sub SubMenu 
  response.write "<block label=""SubMenu"" repeat=""3"">"
  
  '--------------------------------------------------------------------
  ' We need to play the appropriate audio file depending on the contact
  ' information that is stored in the configuration file.
  '--------------------------------------------------------------------
  
  if ((Email = "") and (Phone = "")) then
    response.write "<playaudio value=""nocontactinfo.wav""/>"
	TermDigits = "" 
  elseif ((Email = "") and (Phone = "")) then 
    response.write "<playaudio value=""onlyphone.wav"" " & "termdigits=""1*""/>" 
	TermDigits = "1*"
  elseif ((Email = "") and (Phone = "")) then
    response.write "<playaudio value=""onlyemail.wav"" " & "termdigits=""2*""/>" 
	TermDigits = "2*"
  else 
    response.write "<playaudio value=""bothphoneemail.wav"" " & "termdigits=""12*""/>" 
	TermDigits = "12*"
  end if  ' else statement
  
  '-----------------------
  ' Read the person's name
  '-----------------------
  
  response.write "<text termdigits=""" & TermDigits & """>" & Name & "</text>"	
  
  '---------------------------------------------------------------------------
  ' We do not need to play "Press the Star Key to return to the main menu"
  ' if there is no contact information (because we are already returning there.
  '----------------------------------------------------------------------------
  
  if (TermDigits = "") then
    response.write "<playaudio value=""starkey.wav"" termdigits=""" & TermDigits & """/>"
  end if  ' if statement
  
  '--------------------------------------------------------
  ' We need to use the appropriate event handlers depending
  ' on what contact information we have.
  '--------------------------------------------------------
  
  if (Phone <> "") then 
	response.write "<ontermdigit value=""1"">"
	response.write "<goto value=""contactlist.asp?menu=phone&amp;phone=" & Phone &_
	  			  "&amp;offset=" & Offset & """ " &_
				  "submit=""*"" method=""get""/>"
	response.write "</ontermdigit>"
  end if  ' if statement (Phone exists)
  
  if (Email <> "") then
	response.write "<ontermdigit value=""2"">"
	response.write "<goto value=""contactlist.asp?menu=email&amp;email=" & Email &_
	  			  "&amp;offset=" & Offset & """ " &_
				  "submit=""*"" method=""get""/>"	
	response.write "</ontermdigit>"		
  end if  ' if statement (Email exists)
  
  if ((Email <> "") or (Phone <> "")) then
	response.write "<ontermdigit value=""*"">"
	response.write "<goto value=""contactlist.asp?menu=mainmenu" &_
	  			  "&amp;offset=" & Offset & """ " &_
				  "submit=""*"" method=""get""/>"	
	response.write "</ontermdigit>"		  
  else 
	response.write "<playaudio value=""returningtomainmenu.wav""/>"
	response.write "<goto value=""contactlist.asp?menu=mainmenu&amp;offset=" & Offset & """/>"
  end if  ' else statement  
  
  response.write "<wait value=""3s"" termdigits=""" & TermDigits & """/>"
 
  response.write "</block>"
  
  response.write "<goto value=""contactlist.asp?menu=mainmenu&amp;offset=" & Offset & """/>"  
end sub  ' SubMenu sub

'-------------------------------------------------------------------------------------------

sub EmailMenu
  response.write "<block>"
  response.write "<cleardigits/>"
  response.write "<playaudio value=""EmailMessage.wav"" termdigits=""*'""/>"
  response.write "<recordaudio format=""audio/wav"" " &_
                     "value=""mailto:" & Email & """ " &_
					 "maxtime=""180s"" " &_
					 "maxsilence=""20s"" " &_
					 "cleardigits=""TRUE"" " &_
					 "beep=""TRUE"" " &_
					 "termdigits=""*'""/>"
					 
  response.write "<onerror>"
  response.write "<playaudio value=""errormessage.wav""/>"
  response.write "<goto value=""contactlist.asp?menu=mainmenu&amp;offset=" &_ 
  			      Offset & """/>"   
  response.write "</onerror>"
  
  response.write "<onmaxtime/>"
  response.write "<onmaxsilence/>"
  
  response.write "<ontermdigit value=""*"">"
  response.write "<playaudio value=""messagesent.wav""/>"  
  response.write "<goto value=""contactlist.asp?menu=mainmenu&amp;offset=" &_
  			      Offset & """/>"   
  response.write "</ontermdigit>"
  
  response.write "<ontermdigit value=""'"">"
  response.write "<playaudio value=""messagesent.wav""/>"  
  response.write "<goto value=""contactlist.asp?menu=mainmenu&amp;offset=" &_
  			     Offset & """/>"   
  response.write "</ontermdigit>"  
  
  response.write "</block>"
end sub  ' EmailMenu sub

'-------------------------------------------------------------------------------------------

sub DoTheCall 
  '----------------------------------------------------
  ' This sub does the actual outbound call, and
  ' then sends back the results via callXML <sendevent>
  ' actions.
  '----------------------------------------------------
  
  response.write "<block>"

  response.write "<call value=""" & Phone & """ " &_
                       "maxtime=""25s""/>"
		
  '-----------------------------------------------------
  ' Send back the appropriate event to the other session
  '-----------------------------------------------------
		
  response.write "<onanswer>"
  response.write "<sendevent value=""success"" session=""$parentsessionid;""/>"
  response.write "<wait value=""Unlimited""/>"			   
  response.write "</onanswer>"
  
  response.write "<oncallfailure>"
  response.write "<sendevent value=""busy"" session=""$parentsessionid;""/>"
  response.write "</oncallfailure>"
  
  response.write "<onmaxtime>"
  response.write "<sendevent value=""timedout"" session=""$parentsessionid;""/>"
  response.write "</onmaxtime>"
  
  response.write "<onerror>"
  response.write "<sendevent value=""error"" session=""$parentsessionid;""/>"
  response.write "</onerror>"
  
  response.write "<onexternalevent value=""kill"">"
  response.write "  <hangup/>"
  response.write "</onexternalevent>" 
  
  response.write "</block>"
end sub  ' DoTheCall sub

'----------------------------------------------------------------------------------------

sub PhoneMenu 
  response.write "<block>"
	
  '-------------------------------------------------------
  ' We need to assign a ParentSessionID variable so that
  ' the session we call with the <run> command can send us
  ' a callXML event back.  Without assigning that variable,
  ' there is no way to remember/determine the parent 
  ' session's ID.
  '--------------------------------------------------------
	 
  response.write "<assign var=""parentsessionid"" value=""$session.id;""/>"
	
  response.write "<run value=""contactlist.asp?menu=dothecall" &_ 
        "&amp;phone=" & Phone &_
		"&amp;offset=" & Offset & """ " &_
	    "submit=""*"" " &_
	    "method=""get"" " &_
	    "var=""ChildSession""/>"
	   
  response.write "<block label=""Hold Music"" " &_
	                    "repeat=""3"">"
	   
  '-----------------------------------------------------------------
  ' Play holdmusic while waiting for an event from the other session
  '-----------------------------------------------------------------
		   
  response.write "<playaudio value=""holdmusic.wav""/>"
	   
  '----------------------------------------------------
  ' Conference the call when someone/something picks up
  '----------------------------------------------------
		
  response.write "<onexternalevent value=""success"">"
  response.write "  <conference targetsessions=""$session.eventsenderID;""/>"
  response.write "  <hangup/>"
  response.write "</onexternalevent>"
	 
  '-------------------------------------------
  ' Inform the caller when the number was busy
  '-------------------------------------------
		
  response.write "<onexternalevent value=""busy"">"
  response.write "  <playaudio value=""callfailure.wav""/>"					 
  response.write "  <sendevent value=""kill"" session=""$ChildSession;""/>"
  response.write "  <goto value=""contactlist.asp?menu=mainmenu" &_ 
                    "&amp;offset=" & Offset & """ submit=""*"" method=""get""/>"
  response.write "</onexternalevent>"
	 
  '-------------------------------------------
  ' Inform the caller when the number timedout
  '-------------------------------------------
	
  response.write "<onexternalevent value=""timedout"">"
  response.write "  <playaudio value=""callfailure.wav""/>"					 
  response.write "  <sendevent value=""kill"" session=""$ChildSession;""/>"
  response.write "  <goto value=""contactlist.asp?menu=mainmenu" &_
                   "&amp;offset=" & Offset & """ submit=""*"" method=""get""/>"
  response.write "</onexternalevent>"
	 
  '-----------------------------------------------
  ' Inform the caller when there has been an error
  '-----------------------------------------------  
	 
  response.write "<onexternalevent value=""error"">"
  response.write "  <playaudio value=""callfailure.wav""/>"					 
  response.write "  <sendevent value=""kill"" session=""$ChildSession;""/>"
  response.write "  <goto value=""contactlist.asp?menu=mainmenu" &_
                    "&amp;offset=" & Offset & """ submit=""*"" method=""get""/>"
  response.write "</onexternalevent>"  
	
  response.write "</block>"
	 
  '-------------------------------------------------------
  ' In theory, we shouldn't reach this point.  But just in
  ' case, we might want to give the user a message.
  '-------------------------------------------------------
	 
  response.write "  <playaudio value=""callfailure.wav""/>"					 
  response.write "  <sendevent value=""kill"" session=""$ChildSession;""/>"
  response.write "  <goto value=""contactlist.asp?menu=mainmenu" &_ 
                    "&amp;offset=" & Offset & """ submit=""*"" method=""get""/>"
  response.write "</block>"
end sub  ' PhoneMenu sub

'-------------------------------------------------------------------------------------------

'-------------------------------------------------
' Grab our query string variables here in the main
' body of code so they will be global.
'-------------------------------------------------

Offset = request("offset")
  
if Offset = "" then
  Offset    = 0
  FirstPass = "YES"
end if

Menu   = request("menu")
Email  = request.querystring("email")
Phone  = request.querystring("phone")
Name   = request.querystring("name")

Call Initialize

if Menu = "email" then
  Call EmailMenu
elseif Menu = "submenu" then
  Call SubMenu     
elseif Menu = "phone" then
  Call PhoneMenu
elseif Menu = "dothecall" then
  Call DoTheCall
else 
  Call MainMenu
end if

Call Closure
%>